Updated hook to print messages like prepush

This commit is contained in:
Adam Wright
2016-02-15 18:30:26 -08:00
committed by Adam Wright
parent 7b196400b8
commit 34cf0c8172

View File

@@ -5,12 +5,25 @@
#!/bin/sh #!/bin/sh
# #
# An example hook script to verify what is about to be committed. # Pre-commit hook for the tarpc repository. To use this hook, copy it to .git/hooks in your
# Called by "git commit" with no arguments. The hook should # repository root.
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
# #
# To enable this hook, rename this file to "pre-commit". # Options:
#
# - TARPC_SKIP_RUSTFMT, default = 0
#
# Set this to 1 to skip running rustfmt
RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[0;33m'
NC='\033[0m' # No Color
PREFIX="${GREEN}[PRECOMMIT]${NC}"
FAILURE="${RED}FAILED${NC}"
WARNING="${RED}[WARNING]${NC}"
SKIPPED="${YELLOW}SKIPPED${NC}"
SUCCESS="${GREEN}ok${NC}"
if git rev-parse --verify HEAD >/dev/null 2>&1 if git rev-parse --verify HEAD >/dev/null 2>&1
then then
@@ -20,43 +33,45 @@ else
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904 against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr. # Redirect output to stderr.
exec 1>&2 exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent FAILED=0
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde. printf "${PREFIX} Checking that all filenames are ascii ... "
if [ "$allownonascii" != "true" ] && # Note that the use of brackets around a tr range is ok here, (it's
# Note that the use of brackets around a tr range is ok here, (it's # even required, for portability to Solaris 10's /usr/bin/tr), since
# even required, for portability to Solaris 10's /usr/bin/tr), since # the square bracket bytes happen to fall in the designated range.
# the square bracket bytes happen to fall in the designated range. if test $(git diff --cached --name-only --diff-filter=A -z $against |
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0 LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then then
cat <<\EOF FAILED=1
Error: Attempt to add a non-ASCII file name. printf "${FAILURE}\n"
else
This can cause problems if you want to work with people on other platforms. printf "${SUCCESS}\n"
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit 1
fi fi
# If there are whitespace errors, print the offending file names and fail. printf "${PREFIX} Running rustfmt ... "
exec git diff-index --check --cached $against -- find tarpc/src -name "*.rs" -print0 | xargs -0 rustfmt --write-mode=overwrite &>/dev/null
FMTRESULT=$?
if [ "${TARPC_SKIP_RUSTFMT}" == 1 ]; then
printf "${SKIPPED}\n"
elif [ ${FMTRESULT} != 0 ]; then
FAILED=1
printf "${FAILURE}\n"
else
printf "${SUCCESS}\n"
fi
YELLOW='\033[0;33m' printf "${PREFIX} Checking for bad whitespace ... "
NC='\033[0m' # No Color git diff-index --check --cached $against -- &>/dev/null
if [ "$?" != 0 ]; then
FAILED=1
printf "${FAILURE}\n"
else
printf "${SUCCESS}\n"
fi
function cargo_format() { if [ ${FAILED} != 0 ]; then
echo ${YELLOW}[PRECOMMIT]${NC} Formatting $1 ... exit 1
cargo fmt --manifest-path $1/Cargo.toml &>/dev/null fi
}